;
;   Information.lisp  Thomas MANGIN
;


;
;   Private Functions
;


(defun internal_position (number motif list)
  (if list 
    (if (equal motif (car list))
      number
      (internal_position (+ number 1) motif (cdr list))
     )
    nil
   )
 )


(defun internal_nth (number list)
  (if (= number 0)
    (car list)
    (internal_nth (- number 1) (cdr list))
   )
 )

;
;   Public Functions
;

(defun position (motif list)
  (internal_position 0 motif list)
 )


(defun nth (number list)
  (if (< number 0)
    (break)
    (internal_nth number list)
   )
 )

(defun member (pattern list)
  (if list
    (let* ((head (car list)))
      (if (equal head pattern)
        't
        (if (and (listp head) (member pattern head))
          't	  
          (member pattern (cdr list))
         )
       )
     )
    nil
   )
 )

(defun numberof (list)
  (if liste
    (+ 1 (numberof (cdr list)))
    0
   )
 )


(defun is_number (list) 
  (if list
    (if (numberp (car list))
      (is_number (cdr list))
      (and
        (is_expression (car list))
        (is_number (cdr list))
       )
     )
    't
   )
 )

(defun is_expression (list)
  (if list
    (and
      (listp list)
      (symbolp   (car list))
      (is_number (cdr list))
     )
    't
   )
 )


(defun calcul (list)
  (if (is_expression list)
    (eval list)
    list
   )
 )

