
(defmacro push (element liste)
  `(setq ,liste (cons ,element ,liste))
 )

(defmacro pop (liste)
  `(let ((element (car ,liste)))
     (setq ,liste (cdr ,liste))
     element
    )
 )

(setq OwnStack1 nil)    ; On y pushera le symbole a substituer
(setq OwnStack2 nil)    ;              sa substitution

;
; Remise a zero permettant de tester une nouvelle regle de substitution
;

(defun stack_reset ()
  (setq OwnStack1 nil)
  (setq OwnStack2 nil)
 )


(defun stack_empty ()
  (equal OwnStack1 nil)
 )


(defun pop_rule ()
  (pop OwnStack1)
 )

(defun pop_motif ()
  (pop OwnStack2)
 )


;
; Permet de verifier que element 1 et 2 ne fourment que des paires unique
;

(defun push_couple (element1 element2)
  (let* ((index (position element1 OwnStack1)))
    (if index
        (if (equal (nth index OwnStack2) element2)
          't
	  nil
	 )
      (progn
	(push element1 OwnStack1)
	(push element2 OwnStack2)
	't
       )
     )
   )
 )

;
; Remplacement dans une chaine toutes toute occurence par une autre
;

(defun subst (old new list)
  (if list
    (let ((head (car list)))
      (if (equal head old)
        (cons new (subst old new (cdr list)))
        (if (listp head)
          (cons (subst old new head) (subst old new (cdr list)))
          (cons head                 (subst old new (cdr list)))
         )
       )
     )
    nil
   )
 )



(defun subst (old new list)
  (if (and
        list
        (listp list)
       )
    (let ((head (car list)))
      (if (equal head old)
        (cons new (subst old new (cdr list)))
        (if (listp head)
          (cons (subst old new head) (subst old new (cdr list)))
          (cons head                 (subst old new (cdr list)))
         )
       )
     )
    (if (listp list)
      nil
      (if (equal list old)
        new
        list
       )
     )
   )
 )
