(load "Initialisation.lisp")
(load "SemiUnification.lisp")

; Main program
(semiunification_init)

;Substituable
(u v)

; Rules
(
((D (+ u v)) (+ (D u) (D v)))
((D (* u v)) (+ (* (D u) v) (* u (D v))))
((D (exp u v)) (* v (* (exp u (- v 1)) (D u))))
((D a) 0)
((D b) 0)
((D c) 0)
((D x) 1)
)

;Expression
nil

;Debug Level
0


(debug
  "can_substitute FALSE '(D (+ u u)) '(D (+ (a b) (b c)))" 
  nil
  (can_substitute '(D (+ u u)) '(D (+ (a b) (b c))))
 )

(debug
  "can_substitute FALSE '(D (+ u v)) '(D (+ (a b) (b c) a))"
  nil
  (can_substitute '(D (+ u v)) '(D (+ (a b) (b c) a)))
 )

(debug
  "can_substitute TRUE '(D (+ u v)) '(D (+ (a b) (c b)))"
  't
  (can_substitute '(D (+ u v)) '(D (+ (a b) (c b))))
 )

(debug
  "substitute TRUE '(D u v) '(+ (D u) (D v)) '(D (a b) (c d))" 
  '(+ (D (a b)) (D (c d)))
  (substitute 
    '(D u v)
    '(+ (D u) (D v))
    '(D (a b) (c d)) 
   )
 )

(debug
  "substitute FALSE '(D u v) '(+ (D u) (D v)) '(+ a (D (a b) (c d)))" 
  nil
  (substitute 
    '(D u v)
    '(+ (D u) (D v))
    '(+ a (D (a b) (c d)))
   )
 )

(debug
  "transform TRUE '(D u v) '(+ (D u) (D v)) '((D (a b) (c d)))"
  '((+ (D (a b)) (D (c d))))
  (transform
    '(D u v)
    '(+ (D u) (D v))
    '((D (a b) (c d)))
   )
 )


(debug
  "transform TRUE '(D u v) '(+ (D u) (D v)) '(+ a b (D (a b) (c d)) c)"
  '(+ a b (+ (D (a b)) (D (c d))) c)
  (transform
    '(D u v)
    '(+ (D u) (D v))
    '(+ a b (D (a b) (c d)) c) 
   )
 )

(debug
  "Substitute TRUE '(D u v) '(+ (D u) (D u)) '((D (a b) (c d)))"
  nil
  (substitute
    '(D u u)
    '(+ (D u) (D u))
    '((D (a b) (c d)))
   )
 )

(debug
  "Substitute FALSE '(D u u) '(+ (D u) (D u)) '((D (a b) (c d)))"
  nil
  (substitute
    '(D u u)
    '(+ (D u) (D u))
    '((D (a b) (c d)))
   )
 )

(debug
  "Transform TRUE '(D u v) '(+ (D u) (D v)) '(+ (* a b) (D a c) c)" 
  '(+ (* a b) (+ (D a) (D c)) c)
  (transform
    '(D u v)
    '(+ (D u) (D v))
    '(+ (* a b) (D a c) c)
   )
 )

(debug
  "reduce TRUE RuleIn RuleOut '(+ a b (D (+ x y)) c)" 
  '(+ a b (+ (D x) (D y)) c)
  (reduce
    RuleIn
    RuleOut
  '(+ a b (D (+ x y)) c)
   )
 )

